package de.hamster.scratch.elements.booleans;

import java.util.ArrayList;

import de.hamster.scratch.Renderable;
import de.hamster.scratch.ScratchProgram;
import de.hamster.scratch.elements.BooleanMethodObject;
import de.hamster.scratch.elements.voids.FunctionResultException;


public class NotBooleanObject extends BooleanMethodObject {
	public NotBooleanObject() {
		super("nicht", getParameter());
	}
	
	private static ArrayList<Type> getParameter() {
		ArrayList<Type> parameter = new ArrayList<Type>();
		parameter.add(Type.BOOLEAN);
		return parameter;
	}

	@Override
	public Renderable clone() {
		NotBooleanObject temp = new NotBooleanObject();
		return temp;
	}

	@Override
	public Object performImplementation(ScratchProgram program) throws FunctionResultException {
		// Boolean auswerten
		boolean bool = true;
		if (childs.get(0) != null)
			bool = (Boolean)childs.get(0).perform(program);
		
		// Gesamte Auswertung
		return (!bool);
	}
}
